<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/DocBook/__init__.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/DocBook/__init__.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/DocBook/__init__.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2007 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-string">&quot;&quot;&quot;a DocBook formatter (producing Docbook 4.5 XML output&quot;&quot;&quot;</span></span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG, DeclarationSorter</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters <span class="py-keyword">import</span> quote_name</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.TOC <span class="py-keyword">import</span> TOC</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">from</span> Syntax <span class="py-keyword">import</span> *</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">from</span> Markup.Javadoc <span class="py-keyword">import</span> Javadoc</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">try</span>:</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">    <span class="py-keyword">from</span> Markup.RST <span class="py-keyword">import</span> RST</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-keyword">except</span> ImportError:</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">    <span class="py-keyword">from</span> Markup <span class="py-keyword">import</span> Formatter <span class="py-keyword">as</span> RST</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="py-keyword">import</span> os</span>
<a id="line22"></a><span class="lineno"> 22</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook.html#escape">escape</a>(text):</span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">    <span class="py-keyword">for</span> p <span class="py-keyword">in</span> [(<span class="py-string">'&amp;'</span>, <span class="py-string">'&amp;amp;'</span>), (<span class="py-string">'&quot;'</span>, <span class="py-string">'&amp;quot;'</span>), (<span class="py-string">'&lt;'</span>, <span class="py-string">'&amp;lt;'</span>), (<span class="py-string">'&gt;'</span>, <span class="py-string">'&amp;gt;'</span>),]:</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">        text = text.replace(*p)</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">    <span class="py-keyword">return</span> text</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook.html#reference">reference</a>(name):</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Generate an id suitable as a 'linkend' / 'id' attribute, i.e. for linking.&quot;&quot;&quot;</span></span>
<a id="line31"></a><span class="lineno"> 31</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">    <span class="py-keyword">return</span> quote_name(str(name))</span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/Linker.html">Linker</a>:</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Helper class to be used to resolve references from doc-strings to declarations.&quot;&quot;&quot;</span></span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/Linker.html#link">link</a>(self, decl):</span>
<a id="line38"></a><span class="lineno"> 38</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">        <span class="py-keyword">return</span> reference(decl.name)</span>
<a id="line40"></a><span class="lineno"> 40</span>
<a id="line41"></a><span class="lineno"> 41</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/_BaseClasses.html">_BaseClasses</a>(ASG.Visitor):</span>
<a id="line43"></a><span class="lineno"> 43</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/_BaseClasses.html#__init__">__init__</a>(self):</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        self.classes = [] <span class="py-comment"># accumulated set of classes</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">        self.classes_once = [] <span class="py-comment"># classes not to be included again</span></span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/_BaseClasses.html#visit_declared_type_id">visit_declared_type_id</a>(self, declared):</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">        declared.declaration.accept(self)</span>
<a id="line50"></a><span class="lineno"> 50</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/_BaseClasses.html#visit_class">visit_class</a>(self, class_):</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">        self.classes.append(class_)</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">        <span class="py-keyword">for</span> p <span class="py-keyword">in</span> class_.parents:</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">            p.accept(self)</span>
<a id="line55"></a><span class="lineno"> 55</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/_BaseClasses.html#visit_inheritance">visit_inheritance</a>(self, inheritance):</span>
<a id="line57"></a><span class="lineno"> 57</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">        <span class="py-keyword">if</span> <span class="py-string">'private'</span> <span class="py-keyword">in</span> inheritance.attributes:</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">            <span class="py-keyword">return</span> <span class="py-comment"># Ignore private base classes, they are not visible anyway.</span></span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">        <span class="py-keyword">elif</span> inheritance.parent <span class="py-keyword">in</span> self.classes_once:</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">            <span class="py-keyword">return</span> <span class="py-comment"># Do not include virtual base classes more than once.</span></span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">        <span class="py-keyword">if</span> <span class="py-string">'virtual'</span> <span class="py-keyword">in</span> inheritance.attributes:</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">            self.classes_once.append(inheritance.parent)</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">        inheritance.parent.accept(self)</span>
<a id="line65"></a><span class="lineno"> 65</span>
<a id="line66"></a><span class="lineno"> 66</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">_summary_syntax = {</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">    <span class="py-string">'IDL'</span>: CxxSummarySyntax,</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">    <span class="py-string">'C++'</span>: CxxSummarySyntax,</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">    <span class="py-string">'C'</span>: CxxSummarySyntax,</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">    <span class="py-string">'Python'</span>: PythonSummarySyntax</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">    }</span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">_detail_syntax = {</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">    <span class="py-string">'IDL'</span>: CxxDetailSyntax,</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">    <span class="py-string">'C++'</span>: CxxDetailSyntax,</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">    <span class="py-string">'C'</span>: CxxDetailSyntax,</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    <span class="py-string">'Python'</span>: PythonDetailSyntax</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">    }</span>
<a id="line80"></a><span class="lineno"> 80</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/ModuleLister.html">ModuleLister</a>(ASG.Visitor):</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Maps a module-tree to a (flat) list of modules.&quot;&quot;&quot;</span></span>
<a id="line83"></a><span class="lineno"> 83</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/ModuleLister.html#__init__">__init__</a>(self):</span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        self.modules = []</span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/ModuleLister.html#visit_module">visit_module</a>(self, module):</span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">        self.modules.append(module)</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> module.declarations:</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">            d.accept(self)</span>
<a id="line93"></a><span class="lineno"> 93</span>
<a id="line94"></a><span class="lineno"> 94</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/InheritanceFormatter.html">InheritanceFormatter</a>:</span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/InheritanceFormatter.html#__init__">__init__</a>(self, base_dir, bgcolor):</span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        self.base_dir = base_dir</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">        self.bgcolor = bgcolor</span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/InheritanceFormatter.html#format_class">format_class</a>(self, class_, format):</span>
<a id="line103"></a><span class="lineno">103</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> class_.parents:</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">            <span class="py-keyword">return</span> <span class="py-string">''</span></span>
<a id="line106"></a><span class="lineno">106</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">        <span class="py-keyword">from</span> Synopsis.Formatters <span class="py-keyword">import</span> Dot</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">        filename = os.path.join(self.base_dir, escape(str(class_.name)) + <span class="py-string">'.%s'</span>%format)</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">        dot = Dot.Formatter(bgcolor=self.bgcolor)</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">        <span class="py-keyword">try</span>:</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">            dot.process(IR.IR(asg = ASG.ASG(declarations = [class_])),</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">                        output=filename,</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">                        format=format,</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">                        type=<span class="py-string">'single'</span>)</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">            <span class="py-keyword">return</span> filename</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        <span class="py-keyword">except</span> InvalidCommand, e:</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">'Warning : %s'</span>%str(e)</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">            <span class="py-keyword">return</span> <span class="py-string">''</span></span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span>
<a id="line121"></a><span class="lineno">121</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/FormatterBase.html">FormatterBase</a>:</span>
<a id="line122"></a><span class="lineno">122</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/FormatterBase.html#__init__">__init__</a>(self, processor, output, base_dir,</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">                 nested_modules, secondary_index, inheritance_graphs, graph_color):</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">        self.processor = processor</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">        self.output = output</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        self.base_dir = base_dir</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">        self.nested_modules = nested_modules</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">        self.secondary_index = secondary_index</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">        self.inheritance_graphs = inheritance_graphs</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">        self.graph_color = graph_color</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">        self.__scope = ()</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">        self.__scopestack = []</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">        self.__indent = 0</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">        self.__elements = []</span>
<a id="line136"></a><span class="lineno">136</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/FormatterBase.html#scope">scope</a>(self): <span class="py-keyword">return</span> self.__scope</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/FormatterBase.html#push_scope">push_scope</a>(self, newscope):</span>
<a id="line139"></a><span class="lineno">139</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">        self.__scopestack.append(self.__scope)</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">        self.__scope = newscope</span>
<a id="line142"></a><span class="lineno">142</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/FormatterBase.html#pop_scope">pop_scope</a>(self):</span>
<a id="line144"></a><span class="lineno">144</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">        self.__scope = self.__scopestack[-1]</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">        <span class="py-keyword">del</span> self.__scopestack[-1]</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/FormatterBase.html#write">write</a>(self, text):</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Write some text to the output stream, replacing \n's with \n's and</span></span>
<a id="line150"></a><span class="lineno">150</span><span class="line"><span class="py-string">        indents.&quot;&quot;&quot;</span></span>
<a id="line151"></a><span class="lineno">151</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">        indent = <span class="py-string">' '</span> * self.__indent</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">        self.output.write(text.replace(<span class="py-string">'\n'</span>, <span class="py-string">'\n'</span>+indent))</span>
<a id="line154"></a><span class="lineno">154</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/FormatterBase.html#start_element">start_element</a>(self, type, **params):</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Write the start of an element, ending with a newline&quot;&quot;&quot;</span></span>
<a id="line157"></a><span class="lineno">157</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">        self.__elements.append(type)</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">        param_text = <span class="py-string">''</span></span>
<a id="line160"></a><span class="lineno">160</span><span class="line">        <span class="py-keyword">if</span> params: param_text = <span class="py-string">' '</span> + <span class="py-string">' '</span>.join([<span class="py-string">'%s=&quot;%s&quot;'</span>%(p[0].lower(), p[1]) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> params.items()])</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">        self.write(<span class="py-string">'&lt;'</span> + type + param_text + <span class="py-string">'&gt;'</span>)</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">        self.__indent = self.__indent + 2</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">        self.write(<span class="py-string">'\n'</span>)</span>
<a id="line164"></a><span class="lineno">164</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/FormatterBase.html#end_element">end_element</a>(self):</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Write the end of an element, starting with a newline&quot;&quot;&quot;</span></span>
<a id="line167"></a><span class="lineno">167</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">        type = self.__elements.pop()</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">        self.__indent = self.__indent - 2</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">        self.write(<span class="py-string">'\n&lt;/'</span> + type + <span class="py-string">'&gt;'</span>)</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">        self.write(<span class="py-string">'\n'</span>)</span>
<a id="line172"></a><span class="lineno">172</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/FormatterBase.html#write_element">write_element</a>(self, element, body, end = <span class="py-string">'\n'</span>, **params):</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Write a single element on one line (though body may contain</span></span>
<a id="line175"></a><span class="lineno">175</span><span class="line"><span class="py-string">        newlines)&quot;&quot;&quot;</span></span>
<a id="line176"></a><span class="lineno">176</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">        param_text = <span class="py-string">''</span></span>
<a id="line178"></a><span class="lineno">178</span><span class="line">        <span class="py-keyword">if</span> params: param_text = <span class="py-string">' '</span> + <span class="py-string">' '</span>.join([<span class="py-string">'%s=&quot;%s&quot;'</span>%(p[0].lower(), p[1]) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> params.items()])</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">        self.write(<span class="py-string">'&lt;'</span> + element + param_text + <span class="py-string">'&gt;'</span>)</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">        self.__indent = self.__indent + 2</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">        self.write(body)</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">        self.__indent = self.__indent - 2</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">        self.write(<span class="py-string">'&lt;/'</span> + element + <span class="py-string">'&gt;'</span> + end)</span>
<a id="line184"></a><span class="lineno">184</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/FormatterBase.html#element">element</a>(self, element, body, **params):</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return but do not write the text for an element on one line&quot;&quot;&quot;</span></span>
<a id="line187"></a><span class="lineno">187</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">        param_text = <span class="py-string">''</span></span>
<a id="line189"></a><span class="lineno">189</span><span class="line">        <span class="py-keyword">if</span> params: param_text = <span class="py-string">' '</span> + <span class="py-string">' '</span>.join([<span class="py-string">'%s=&quot;%s&quot;'</span>%(p[0].lower(), p[1]) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> params.items()])</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'&lt;%s%s&gt;%s&lt;/%s&gt;'</span>%(element, param_text, body, element)</span>
<a id="line191"></a><span class="lineno">191</span>
<a id="line192"></a><span class="lineno">192</span>
<a id="line193"></a><span class="lineno">193</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/SummaryFormatter.html">SummaryFormatter</a>(FormatterBase, ASG.Visitor):</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A SummaryFormatter.&quot;&quot;&quot;</span></span>
<a id="line195"></a><span class="lineno">195</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/SummaryFormatter.html#process_doc">process_doc</a>(self, decl):</span>
<a id="line197"></a><span class="lineno">197</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">        <span class="py-keyword">if</span> decl.annotations.get(<span class="py-string">'doc'</span>, <span class="py-string">''</span>):</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">            summary = self.processor.documentation.summary(decl)</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">            <span class="py-keyword">if</span> summary:</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">                <span class="py-comment"># FIXME: Unfortunately, as of xsl-docbook 1.73, a section role</span></span>
<a id="line202"></a><span class="lineno">202</span><span class="line">                <span class="py-comment">#        doesn't translate into a div class attribute, so there</span></span>
<a id="line203"></a><span class="lineno">203</span><span class="line">                <span class="py-comment">#        is no way to style summaries and descriptions per se.</span></span>
<a id="line204"></a><span class="lineno">204</span><span class="line">                <span class="py-comment">#self.write('&lt;section role=&quot;summary&quot;&gt;\n%s&lt;section&gt;\n'%summary)</span></span>
<a id="line205"></a><span class="lineno">205</span><span class="line">                self.write(<span class="py-string">'%s\n'</span>%summary)</span>
<a id="line206"></a><span class="lineno">206</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">    <span class="py-comment">#################### ASG Visitor ###########################################</span></span>
<a id="line208"></a><span class="lineno">208</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/SummaryFormatter.html#visit_declaration">visit_declaration</a>(self, declaration):</span>
<a id="line210"></a><span class="lineno">210</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">        language = declaration.file.annotations[<span class="py-string">'language'</span>]</span>
<a id="line212"></a><span class="lineno">212</span><span class="line">        syntax = _summary_syntax[language](self.output)</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">        declaration.accept(syntax)</span>
<a id="line214"></a><span class="lineno">214</span><span class="line">        syntax.finish()</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">        self.process_doc(declaration)</span>
<a id="line216"></a><span class="lineno">216</span>
<a id="line217"></a><span class="lineno">217</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">    visit_module = visit_declaration</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">    visit_class = visit_declaration</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/SummaryFormatter.html#visit_meta_module">visit_meta_module</a>(self, meta):</span>
<a id="line221"></a><span class="lineno">221</span><span class="line">        self.visit_module(meta.module_declarations[0])</span>
<a id="line222"></a><span class="lineno">222</span>
<a id="line223"></a><span class="lineno">223</span><span class="line">    visit_function = visit_declaration</span>
<a id="line224"></a><span class="lineno">224</span>
<a id="line225"></a><span class="lineno">225</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/SummaryFormatter.html#visit_enum">visit_enum</a>(self, enum):</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">        <span class="py-keyword">print</span> <span class="py-string">&quot;sorry, &lt;enum&gt; not implemented&quot;</span></span>
<a id="line227"></a><span class="lineno">227</span>
<a id="line228"></a><span class="lineno">228</span>
<a id="line229"></a><span class="lineno">229</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html">DetailFormatter</a>(FormatterBase, ASG.Visitor):</span>
<a id="line230"></a><span class="lineno">230</span>
<a id="line231"></a><span class="lineno">231</span>
<a id="line232"></a><span class="lineno">232</span><span class="line">    <span class="py-comment">#################### Type Visitor ##########################################</span></span>
<a id="line233"></a><span class="lineno">233</span>
<a id="line234"></a><span class="lineno">234</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_builtin_type_id">visit_builtin_type_id</a>(self, type):</span>
<a id="line235"></a><span class="lineno">235</span>
<a id="line236"></a><span class="lineno">236</span><span class="line">        self.__type_ref = str(type.name)</span>
<a id="line237"></a><span class="lineno">237</span><span class="line">        self.__type_label = str(type.name)</span>
<a id="line238"></a><span class="lineno">238</span>
<a id="line239"></a><span class="lineno">239</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_unknown_type_id">visit_unknown_type_id</a>(self, type):</span>
<a id="line240"></a><span class="lineno">240</span>
<a id="line241"></a><span class="lineno">241</span><span class="line">        self.__type_ref = str(type.name)</span>
<a id="line242"></a><span class="lineno">242</span><span class="line">        self.__type_label = str(self.scope().prune(type.name))</span>
<a id="line243"></a><span class="lineno">243</span>
<a id="line244"></a><span class="lineno">244</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_declared_type_id">visit_declared_type_id</a>(self, type):</span>
<a id="line245"></a><span class="lineno">245</span>
<a id="line246"></a><span class="lineno">246</span><span class="line">        self.__type_label = str(self.scope().prune(type.name))</span>
<a id="line247"></a><span class="lineno">247</span><span class="line">        self.__type_ref = str(type.name)</span>
<a id="line248"></a><span class="lineno">248</span>
<a id="line249"></a><span class="lineno">249</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_modifier_type_id">visit_modifier_type_id</a>(self, type):</span>
<a id="line250"></a><span class="lineno">250</span>
<a id="line251"></a><span class="lineno">251</span><span class="line">        type.alias.accept(self)</span>
<a id="line252"></a><span class="lineno">252</span><span class="line">        self.__type_ref = <span class="py-string">''</span>.join(type.premod) + <span class="py-string">' '</span> + self.__type_ref + <span class="py-string">' '</span> + <span class="py-string">''</span>.join(type.postmod)</span>
<a id="line253"></a><span class="lineno">253</span><span class="line">        self.__type_label = escape(<span class="py-string">''</span>.join(type.premod) + <span class="py-string">' '</span> + self.__type_label + <span class="py-string">' '</span> + <span class="py-string">''</span>.join(type.postmod))</span>
<a id="line254"></a><span class="lineno">254</span>
<a id="line255"></a><span class="lineno">255</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_parametrized_type_id">visit_parametrized_type_id</a>(self, type):</span>
<a id="line256"></a><span class="lineno">256</span>
<a id="line257"></a><span class="lineno">257</span><span class="line">        type.template.accept(self)</span>
<a id="line258"></a><span class="lineno">258</span><span class="line">        type_label = self.__type_label + <span class="py-string">'&amp;lt;'</span></span>
<a id="line259"></a><span class="lineno">259</span><span class="line">        parameters_label = []</span>
<a id="line260"></a><span class="lineno">260</span><span class="line">        <span class="py-keyword">for</span> p <span class="py-keyword">in</span> type.parameters:</span>
<a id="line261"></a><span class="lineno">261</span><span class="line">            p.accept(self)</span>
<a id="line262"></a><span class="lineno">262</span><span class="line">            parameters_label.append(self.__type_label)</span>
<a id="line263"></a><span class="lineno">263</span><span class="line">        self.__type_label = type_label + <span class="py-string">', '</span>.join(parameters_label) + <span class="py-string">'&amp;gt;'</span></span>
<a id="line264"></a><span class="lineno">264</span>
<a id="line265"></a><span class="lineno">265</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_function_type_id">visit_function_type_id</a>(self, type):</span>
<a id="line266"></a><span class="lineno">266</span>
<a id="line267"></a><span class="lineno">267</span><span class="line">        <span class="py-comment"># TODO: this needs to be implemented</span></span>
<a id="line268"></a><span class="lineno">268</span><span class="line">        self.__type_ref = <span class="py-string">'function_type'</span></span>
<a id="line269"></a><span class="lineno">269</span><span class="line">        self.__type_label = <span class="py-string">'function_type'</span></span>
<a id="line270"></a><span class="lineno">270</span>
<a id="line271"></a><span class="lineno">271</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#process_doc">process_doc</a>(self, decl):</span>
<a id="line272"></a><span class="lineno">272</span>
<a id="line273"></a><span class="lineno">273</span><span class="line">        <span class="py-keyword">if</span> decl.annotations.get(<span class="py-string">'doc'</span>, <span class="py-string">''</span>):</span>
<a id="line274"></a><span class="lineno">274</span><span class="line">            detail = self.processor.documentation.details(decl)</span>
<a id="line275"></a><span class="lineno">275</span><span class="line">            <span class="py-keyword">if</span> detail:</span>
<a id="line276"></a><span class="lineno">276</span><span class="line">                <span class="py-comment"># FIXME: Unfortunately, as of xsl-docbook 1.73, a section role</span></span>
<a id="line277"></a><span class="lineno">277</span><span class="line">                <span class="py-comment">#        doesn't translate into a div class attribute, so there</span></span>
<a id="line278"></a><span class="lineno">278</span><span class="line">                <span class="py-comment">#        is no way to style summaries and descriptions per se.</span></span>
<a id="line279"></a><span class="lineno">279</span><span class="line">                <span class="py-comment">#self.write('&lt;section role=&quot;description&quot;&gt;\n%s&lt;section&gt;\n'%detail)</span></span>
<a id="line280"></a><span class="lineno">280</span><span class="line">                self.write(<span class="py-string">'%s\n'</span>%detail)</span>
<a id="line281"></a><span class="lineno">281</span>
<a id="line282"></a><span class="lineno">282</span><span class="line">    <span class="py-comment">#################### ASG Visitor ###########################################</span></span>
<a id="line283"></a><span class="lineno">283</span>
<a id="line284"></a><span class="lineno">284</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_declaration">visit_declaration</a>(self, declaration):</span>
<a id="line285"></a><span class="lineno">285</span><span class="line">        <span class="py-keyword">if</span> self.processor.hide_undocumented <span class="py-keyword">and</span> <span class="py-keyword">not</span> declaration.annotations.get(<span class="py-string">'doc'</span>):</span>
<a id="line286"></a><span class="lineno">286</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line287"></a><span class="lineno">287</span><span class="line">        self.start_element(<span class="py-string">'section'</span>, id=reference(declaration.name))</span>
<a id="line288"></a><span class="lineno">288</span><span class="line">        self.write_element(<span class="py-string">'title'</span>, escape(declaration.name[-1]))</span>
<a id="line289"></a><span class="lineno">289</span><span class="line">        <span class="py-keyword">if</span> isinstance(declaration, ASG.Function):</span>
<a id="line290"></a><span class="lineno">290</span><span class="line">            <span class="py-comment"># The primary index term is the unqualified name,</span></span>
<a id="line291"></a><span class="lineno">291</span><span class="line">            <span class="py-comment"># the secondary the qualified name.</span></span>
<a id="line292"></a><span class="lineno">292</span><span class="line">            <span class="py-comment"># This will result in index terms being grouped by name, with each</span></span>
<a id="line293"></a><span class="lineno">293</span><span class="line">            <span class="py-comment"># qualified name being listed within that group.</span></span>
<a id="line294"></a><span class="lineno">294</span><span class="line">            indexterm = self.element(<span class="py-string">'primary'</span>, escape(declaration.real_name[-1]))</span>
<a id="line295"></a><span class="lineno">295</span><span class="line">            <span class="py-keyword">if</span> self.secondary_index:</span>
<a id="line296"></a><span class="lineno">296</span><span class="line">                indexterm += self.element(<span class="py-string">'secondary'</span>, escape(str(declaration.real_name)))</span>
<a id="line297"></a><span class="lineno">297</span><span class="line">            self.write_element(<span class="py-string">'indexterm'</span>, indexterm, type=<span class="py-string">'functions'</span>)</span>
<a id="line298"></a><span class="lineno">298</span>
<a id="line299"></a><span class="lineno">299</span><span class="line">        language = declaration.file.annotations[<span class="py-string">'language'</span>]</span>
<a id="line300"></a><span class="lineno">300</span><span class="line">        syntax = _detail_syntax[language](self.output)</span>
<a id="line301"></a><span class="lineno">301</span><span class="line">        declaration.accept(syntax)</span>
<a id="line302"></a><span class="lineno">302</span><span class="line">        syntax.finish()</span>
<a id="line303"></a><span class="lineno">303</span><span class="line">        self.process_doc(declaration)</span>
<a id="line304"></a><span class="lineno">304</span><span class="line">        self.end_element()</span>
<a id="line305"></a><span class="lineno">305</span>
<a id="line306"></a><span class="lineno">306</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#generate_module_list">generate_module_list</a>(self, modules):</span>
<a id="line307"></a><span class="lineno">307</span>
<a id="line308"></a><span class="lineno">308</span><span class="line">        <span class="py-keyword">if</span> modules:</span>
<a id="line309"></a><span class="lineno">309</span><span class="line">            modules.sort(cmp=<span class="py-keyword">lambda</span> a,b:cmp(a.name, b.name))</span>
<a id="line310"></a><span class="lineno">310</span><span class="line">            self.start_element(<span class="py-string">'section'</span>)</span>
<a id="line311"></a><span class="lineno">311</span><span class="line">            self.write_element(<span class="py-string">'title'</span>, modules[0].type.capitalize() + <span class="py-string">'s'</span>)</span>
<a id="line312"></a><span class="lineno">312</span><span class="line">            self.start_element(<span class="py-string">'itemizedlist'</span>)</span>
<a id="line313"></a><span class="lineno">313</span><span class="line">            <span class="py-keyword">for</span> m <span class="py-keyword">in</span> modules:</span>
<a id="line314"></a><span class="lineno">314</span><span class="line">                link = self.element(<span class="py-string">'link'</span>, escape(str(m.name)), linkend=reference(m.name))</span>
<a id="line315"></a><span class="lineno">315</span><span class="line">                self.write_element(<span class="py-string">'listitem'</span>, self.element(<span class="py-string">'para'</span>, link))</span>
<a id="line316"></a><span class="lineno">316</span><span class="line">            self.end_element()</span>
<a id="line317"></a><span class="lineno">317</span><span class="line">            self.end_element()</span>
<a id="line318"></a><span class="lineno">318</span>
<a id="line319"></a><span class="lineno">319</span>
<a id="line320"></a><span class="lineno">320</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#format_module_or_group">format_module_or_group</a>(self, module, title, sort):</span>
<a id="line321"></a><span class="lineno">321</span><span class="line">        self.start_element(<span class="py-string">'section'</span>, id=reference(module.name))</span>
<a id="line322"></a><span class="lineno">322</span><span class="line">        self.write_element(<span class="py-string">'title'</span>, title)</span>
<a id="line323"></a><span class="lineno">323</span>
<a id="line324"></a><span class="lineno">324</span><span class="line">        declarations = module.declarations</span>
<a id="line325"></a><span class="lineno">325</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.nested_modules:</span>
<a id="line326"></a><span class="lineno">326</span><span class="line">            modules = [d <span class="py-keyword">for</span> d <span class="py-keyword">in</span> declarations <span class="py-keyword">if</span> isinstance(d, ASG.Module)]</span>
<a id="line327"></a><span class="lineno">327</span><span class="line">            declarations = [d <span class="py-keyword">for</span> d <span class="py-keyword">in</span> declarations <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(d, ASG.Module)]</span>
<a id="line328"></a><span class="lineno">328</span><span class="line">            self.generate_module_list(modules)</span>
<a id="line329"></a><span class="lineno">329</span>
<a id="line330"></a><span class="lineno">330</span><span class="line">        sorter = DeclarationSorter.DeclarationSorter(declarations,</span>
<a id="line331"></a><span class="lineno">331</span><span class="line">                                                     group_as_section=False)</span>
<a id="line332"></a><span class="lineno">332</span><span class="line">        <span class="py-keyword">if</span> self.processor.generate_summary:</span>
<a id="line333"></a><span class="lineno">333</span><span class="line">            self.start_element(<span class="py-string">'section'</span>)</span>
<a id="line334"></a><span class="lineno">334</span><span class="line">            self.write_element(<span class="py-string">'title'</span>, <span class="py-string">'Summary'</span>)</span>
<a id="line335"></a><span class="lineno">335</span><span class="line">            summary = SummaryFormatter(self.processor, self.output)</span>
<a id="line336"></a><span class="lineno">336</span><span class="line">            <span class="py-keyword">if</span> sort:</span>
<a id="line337"></a><span class="lineno">337</span><span class="line">                <span class="py-keyword">for</span> s <span class="py-keyword">in</span> sorter:</span>
<a id="line338"></a><span class="lineno">338</span><span class="line">                    <span class="py-comment">#if s[-1] == 's': title = s + 'es Summary'</span></span>
<a id="line339"></a><span class="lineno">339</span><span class="line">                    <span class="py-comment">#else: title = s + 's Summary'</span></span>
<a id="line340"></a><span class="lineno">340</span><span class="line">                    <span class="py-comment">#self.start_element('section')</span></span>
<a id="line341"></a><span class="lineno">341</span><span class="line">                    <span class="py-comment">#self.write_element('title', escape(title))</span></span>
<a id="line342"></a><span class="lineno">342</span><span class="line">                    <span class="py-keyword">for</span> d <span class="py-keyword">in</span> sorter[s]:</span>
<a id="line343"></a><span class="lineno">343</span><span class="line">                        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.processor.hide_undocumented <span class="py-keyword">or</span> d.annotations.get(<span class="py-string">'doc'</span>):</span>
<a id="line344"></a><span class="lineno">344</span><span class="line">                            d.accept(summary)</span>
<a id="line345"></a><span class="lineno">345</span><span class="line">                    <span class="py-comment">#self.end_element()</span></span>
<a id="line346"></a><span class="lineno">346</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line347"></a><span class="lineno">347</span><span class="line">                <span class="py-keyword">for</span> d <span class="py-keyword">in</span> declarations:</span>
<a id="line348"></a><span class="lineno">348</span><span class="line">                    <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.processor.hide_undocumented <span class="py-keyword">or</span> d.annotations.get(<span class="py-string">'doc'</span>):</span>
<a id="line349"></a><span class="lineno">349</span><span class="line">                        d.accept(summary)</span>
<a id="line350"></a><span class="lineno">350</span><span class="line">            self.end_element()</span>
<a id="line351"></a><span class="lineno">351</span><span class="line">            self.write(<span class="py-string">'\n'</span>)</span>
<a id="line352"></a><span class="lineno">352</span><span class="line">            self.start_element(<span class="py-string">'section'</span>)</span>
<a id="line353"></a><span class="lineno">353</span><span class="line">            self.write_element(<span class="py-string">'title'</span>, <span class="py-string">'Details'</span>)</span>
<a id="line354"></a><span class="lineno">354</span><span class="line">        self.process_doc(module)</span>
<a id="line355"></a><span class="lineno">355</span><span class="line">        self.push_scope(module.name)</span>
<a id="line356"></a><span class="lineno">356</span><span class="line">        suffix = self.processor.generate_summary <span class="py-keyword">and</span> <span class="py-string">' Details'</span> <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line357"></a><span class="lineno">357</span><span class="line">        <span class="py-keyword">if</span> sort:</span>
<a id="line358"></a><span class="lineno">358</span><span class="line">            <span class="py-keyword">for</span> section <span class="py-keyword">in</span> sorter:</span>
<a id="line359"></a><span class="lineno">359</span><span class="line">                <span class="py-comment">#title = section + suffix</span></span>
<a id="line360"></a><span class="lineno">360</span><span class="line">                <span class="py-comment">#self.start_element('section')</span></span>
<a id="line361"></a><span class="lineno">361</span><span class="line">                <span class="py-comment">#self.write_element('title', escape(title))</span></span>
<a id="line362"></a><span class="lineno">362</span><span class="line">                <span class="py-keyword">for</span> d <span class="py-keyword">in</span> sorter[section]:</span>
<a id="line363"></a><span class="lineno">363</span><span class="line">                    d.accept(self)</span>
<a id="line364"></a><span class="lineno">364</span><span class="line">                <span class="py-comment">#self.end_element()</span></span>
<a id="line365"></a><span class="lineno">365</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line366"></a><span class="lineno">366</span><span class="line">            <span class="py-keyword">for</span> d <span class="py-keyword">in</span> declarations:</span>
<a id="line367"></a><span class="lineno">367</span><span class="line">                d.accept(self)</span>
<a id="line368"></a><span class="lineno">368</span><span class="line">        self.pop_scope()</span>
<a id="line369"></a><span class="lineno">369</span><span class="line">        self.end_element()</span>
<a id="line370"></a><span class="lineno">370</span><span class="line">        self.write(<span class="py-string">'\n'</span>)</span>
<a id="line371"></a><span class="lineno">371</span><span class="line">        <span class="py-keyword">if</span> self.processor.generate_summary:</span>
<a id="line372"></a><span class="lineno">372</span><span class="line">            self.end_element()</span>
<a id="line373"></a><span class="lineno">373</span><span class="line">            self.write(<span class="py-string">'\n'</span>)</span>
<a id="line374"></a><span class="lineno">374</span>
<a id="line375"></a><span class="lineno">375</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_module">visit_module</a>(self, module):</span>
<a id="line376"></a><span class="lineno">376</span><span class="line">        <span class="py-keyword">if</span> module.name:</span>
<a id="line377"></a><span class="lineno">377</span><span class="line">            <span class="py-comment"># Only print qualified names when modules are flattened.</span></span>
<a id="line378"></a><span class="lineno">378</span><span class="line">            name = self.nested_modules <span class="py-keyword">and</span> module.name[-1] <span class="py-keyword">or</span> str(module.name)</span>
<a id="line379"></a><span class="lineno">379</span><span class="line">            title = <span class="py-string">'%s %s'</span>%(module.type.capitalize(), name)</span>
<a id="line380"></a><span class="lineno">380</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line381"></a><span class="lineno">381</span><span class="line">            title = <span class="py-string">'Global %s'</span>%module.type.capitalize()</span>
<a id="line382"></a><span class="lineno">382</span>
<a id="line383"></a><span class="lineno">383</span><span class="line">        self.format_module_or_group(module, title, True)</span>
<a id="line384"></a><span class="lineno">384</span>
<a id="line385"></a><span class="lineno">385</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_group">visit_group</a>(self, group):</span>
<a id="line386"></a><span class="lineno">386</span><span class="line">        self.format_module_or_group(group, group.name[-1].capitalize(), False)</span>
<a id="line387"></a><span class="lineno">387</span>
<a id="line388"></a><span class="lineno">388</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_class">visit_class</a>(self, class_):</span>
<a id="line389"></a><span class="lineno">389</span>
<a id="line390"></a><span class="lineno">390</span><span class="line">        <span class="py-keyword">if</span> self.processor.hide_undocumented <span class="py-keyword">and</span> <span class="py-keyword">not</span> class_.annotations.get(<span class="py-string">'doc'</span>):</span>
<a id="line391"></a><span class="lineno">391</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line392"></a><span class="lineno">392</span><span class="line">        self.start_element(<span class="py-string">'section'</span>, id=reference(class_.name))</span>
<a id="line393"></a><span class="lineno">393</span><span class="line">        title = <span class="py-string">'%s %s'</span>%(class_.type, class_.name[-1])</span>
<a id="line394"></a><span class="lineno">394</span><span class="line">        self.write_element(<span class="py-string">'title'</span>, escape(title))</span>
<a id="line395"></a><span class="lineno">395</span><span class="line">        indexterm = self.element(<span class="py-string">'primary'</span>, escape(class_.name[-1]))</span>
<a id="line396"></a><span class="lineno">396</span><span class="line">        <span class="py-keyword">if</span> self.secondary_index:</span>
<a id="line397"></a><span class="lineno">397</span><span class="line">            indexterm += self.element(<span class="py-string">'secondary'</span>, escape(str(class_.name)))</span>
<a id="line398"></a><span class="lineno">398</span><span class="line">        self.write_element(<span class="py-string">'indexterm'</span>, indexterm, type=<span class="py-string">'types'</span>)</span>
<a id="line399"></a><span class="lineno">399</span>
<a id="line400"></a><span class="lineno">400</span><span class="line">        <span class="py-keyword">if</span> self.inheritance_graphs:</span>
<a id="line401"></a><span class="lineno">401</span><span class="line">            formatter = InheritanceFormatter(os.path.join(self.base_dir, <span class="py-string">'images'</span>),</span>
<a id="line402"></a><span class="lineno">402</span><span class="line">                                             self.graph_color)</span>
<a id="line403"></a><span class="lineno">403</span><span class="line">            png = formatter.format_class(class_, <span class="py-string">'png'</span>)</span>
<a id="line404"></a><span class="lineno">404</span><span class="line">            svg = formatter.format_class(class_, <span class="py-string">'svg'</span>)</span>
<a id="line405"></a><span class="lineno">405</span><span class="line">            <span class="py-keyword">if</span> png <span class="py-keyword">or</span> svg:</span>
<a id="line406"></a><span class="lineno">406</span><span class="line">                self.start_element(<span class="py-string">'mediaobject'</span>)</span>
<a id="line407"></a><span class="lineno">407</span><span class="line">                <span class="py-keyword">if</span> png:</span>
<a id="line408"></a><span class="lineno">408</span><span class="line">                    imagedata = self.element(<span class="py-string">'imagedata'</span>, <span class="py-string">''</span>, fileref=png, format=<span class="py-string">'PNG'</span>)</span>
<a id="line409"></a><span class="lineno">409</span><span class="line">                    self.write_element(<span class="py-string">'imageobject'</span>, imagedata)</span>
<a id="line410"></a><span class="lineno">410</span><span class="line">                <span class="py-keyword">if</span> svg:</span>
<a id="line411"></a><span class="lineno">411</span><span class="line">                    imagedata = self.element(<span class="py-string">'imagedata'</span>, <span class="py-string">''</span>, fileref=svg, format=<span class="py-string">'SVG'</span>)</span>
<a id="line412"></a><span class="lineno">412</span><span class="line">                    self.write_element(<span class="py-string">'imageobject'</span>, imagedata)</span>
<a id="line413"></a><span class="lineno">413</span><span class="line">                self.end_element()</span>
<a id="line414"></a><span class="lineno">414</span>
<a id="line415"></a><span class="lineno">415</span><span class="line">        declarations = class_.declarations</span>
<a id="line416"></a><span class="lineno">416</span><span class="line">        <span class="py-comment"># If so desired, flatten inheritance tree</span></span>
<a id="line417"></a><span class="lineno">417</span><span class="line">        <span class="py-keyword">if</span> self.processor.inline_inherited_members:</span>
<a id="line418"></a><span class="lineno">418</span><span class="line">            declarations = class_.declarations[:]</span>
<a id="line419"></a><span class="lineno">419</span><span class="line">            bases = _BaseClasses()</span>
<a id="line420"></a><span class="lineno">420</span><span class="line">            <span class="py-keyword">for</span> i <span class="py-keyword">in</span> class_.parents:</span>
<a id="line421"></a><span class="lineno">421</span><span class="line">                bases.visit_inheritance(i)</span>
<a id="line422"></a><span class="lineno">422</span><span class="line">            <span class="py-keyword">for</span> base <span class="py-keyword">in</span> bases.classes:</span>
<a id="line423"></a><span class="lineno">423</span><span class="line">                <span class="py-keyword">for</span> d <span class="py-keyword">in</span> base.declarations:</span>
<a id="line424"></a><span class="lineno">424</span><span class="line">                    <span class="py-keyword">if</span> type(d) == ASG.Operation:</span>
<a id="line425"></a><span class="lineno">425</span><span class="line">                        <span class="py-keyword">if</span> d.real_name[-1] == base.name[-1]:</span>
<a id="line426"></a><span class="lineno">426</span><span class="line">                            <span class="py-comment"># Constructor</span></span>
<a id="line427"></a><span class="lineno">427</span><span class="line">                            <span class="py-keyword">continue</span></span>
<a id="line428"></a><span class="lineno">428</span><span class="line">                        <span class="py-keyword">elif</span> d.real_name[-1] == <span class="py-string">'~'</span> + base.name[-1]:</span>
<a id="line429"></a><span class="lineno">429</span><span class="line">                            <span class="py-comment"># Destructor</span></span>
<a id="line430"></a><span class="lineno">430</span><span class="line">                            <span class="py-keyword">continue</span></span>
<a id="line431"></a><span class="lineno">431</span><span class="line">                        <span class="py-keyword">elif</span> d.real_name[-1] == <span class="py-string">'operator='</span>:</span>
<a id="line432"></a><span class="lineno">432</span><span class="line">                            <span class="py-comment"># Assignment</span></span>
<a id="line433"></a><span class="lineno">433</span><span class="line">                            <span class="py-keyword">continue</span></span>
<a id="line434"></a><span class="lineno">434</span><span class="line">                    declarations.append(d)</span>
<a id="line435"></a><span class="lineno">435</span>
<a id="line436"></a><span class="lineno">436</span><span class="line">        sorter = DeclarationSorter.DeclarationSorter(declarations,</span>
<a id="line437"></a><span class="lineno">437</span><span class="line">                                                     group_as_section=False)</span>
<a id="line438"></a><span class="lineno">438</span>
<a id="line439"></a><span class="lineno">439</span><span class="line">        <span class="py-keyword">if</span> self.processor.generate_summary:</span>
<a id="line440"></a><span class="lineno">440</span><span class="line">            self.start_element(<span class="py-string">'section'</span>)</span>
<a id="line441"></a><span class="lineno">441</span><span class="line">            self.write_element(<span class="py-string">'title'</span>, <span class="py-string">'Summary'</span>)</span>
<a id="line442"></a><span class="lineno">442</span><span class="line">            summary = SummaryFormatter(self.processor, self.output)</span>
<a id="line443"></a><span class="lineno">443</span><span class="line">            summary.process_doc(class_)</span>
<a id="line444"></a><span class="lineno">444</span><span class="line">            <span class="py-keyword">for</span> section <span class="py-keyword">in</span> sorter:</span>
<a id="line445"></a><span class="lineno">445</span><span class="line">                <span class="py-comment">#title = section + ' Summary'</span></span>
<a id="line446"></a><span class="lineno">446</span><span class="line">                <span class="py-comment">#self.start_element('section')</span></span>
<a id="line447"></a><span class="lineno">447</span><span class="line">                <span class="py-comment">#self.write_element('title', escape(title))</span></span>
<a id="line448"></a><span class="lineno">448</span><span class="line">                <span class="py-keyword">for</span> d <span class="py-keyword">in</span> sorter[section]:</span>
<a id="line449"></a><span class="lineno">449</span><span class="line">                    <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.processor.hide_undocumented <span class="py-keyword">or</span> d.annotations.get(<span class="py-string">'doc'</span>):</span>
<a id="line450"></a><span class="lineno">450</span><span class="line">                        d.accept(summary)</span>
<a id="line451"></a><span class="lineno">451</span><span class="line">                <span class="py-comment">#self.end_element()</span></span>
<a id="line452"></a><span class="lineno">452</span><span class="line">            self.end_element()</span>
<a id="line453"></a><span class="lineno">453</span><span class="line">            self.write(<span class="py-string">'\n'</span>)</span>
<a id="line454"></a><span class="lineno">454</span><span class="line">            self.start_element(<span class="py-string">'section'</span>)</span>
<a id="line455"></a><span class="lineno">455</span><span class="line">            self.write_element(<span class="py-string">'title'</span>, <span class="py-string">'Details'</span>)</span>
<a id="line456"></a><span class="lineno">456</span><span class="line">        self.process_doc(class_)</span>
<a id="line457"></a><span class="lineno">457</span><span class="line">        self.push_scope(class_.name)</span>
<a id="line458"></a><span class="lineno">458</span><span class="line">        suffix = self.processor.generate_summary <span class="py-keyword">and</span> <span class="py-string">' Details'</span> <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line459"></a><span class="lineno">459</span><span class="line">        <span class="py-keyword">for</span> section <span class="py-keyword">in</span> sorter:</span>
<a id="line460"></a><span class="lineno">460</span><span class="line">            <span class="py-comment">#title = section + suffix</span></span>
<a id="line461"></a><span class="lineno">461</span><span class="line">            <span class="py-comment">#self.start_element('section')</span></span>
<a id="line462"></a><span class="lineno">462</span><span class="line">            <span class="py-comment">#self.write_element('title', escape(title))</span></span>
<a id="line463"></a><span class="lineno">463</span><span class="line">            <span class="py-keyword">for</span> d <span class="py-keyword">in</span> sorter[section]:</span>
<a id="line464"></a><span class="lineno">464</span><span class="line">                d.accept(self)</span>
<a id="line465"></a><span class="lineno">465</span><span class="line">            <span class="py-comment">#self.end_element()</span></span>
<a id="line466"></a><span class="lineno">466</span><span class="line">        self.pop_scope()</span>
<a id="line467"></a><span class="lineno">467</span><span class="line">        self.end_element()</span>
<a id="line468"></a><span class="lineno">468</span><span class="line">        self.write(<span class="py-string">'\n'</span>)</span>
<a id="line469"></a><span class="lineno">469</span><span class="line">        <span class="py-keyword">if</span> self.processor.generate_summary:</span>
<a id="line470"></a><span class="lineno">470</span><span class="line">            self.end_element()</span>
<a id="line471"></a><span class="lineno">471</span><span class="line">            self.write(<span class="py-string">'\n'</span>)</span>
<a id="line472"></a><span class="lineno">472</span>
<a id="line473"></a><span class="lineno">473</span>
<a id="line474"></a><span class="lineno">474</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_inheritance">visit_inheritance</a>(self, inheritance):</span>
<a id="line475"></a><span class="lineno">475</span>
<a id="line476"></a><span class="lineno">476</span><span class="line">        <span class="py-keyword">for</span> a <span class="py-keyword">in</span> inheritance.attributes: self.element(<span class="py-string">&quot;modifier&quot;</span>, a)</span>
<a id="line477"></a><span class="lineno">477</span><span class="line">        self.element(<span class="py-string">&quot;classname&quot;</span>, str(self.scope().prune((inheritance.parent.name))))</span>
<a id="line478"></a><span class="lineno">478</span>
<a id="line479"></a><span class="lineno">479</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_parameter">visit_parameter</a>(self, parameter):</span>
<a id="line480"></a><span class="lineno">480</span>
<a id="line481"></a><span class="lineno">481</span><span class="line">        parameter.type.accept(self)</span>
<a id="line482"></a><span class="lineno">482</span>
<a id="line483"></a><span class="lineno">483</span><span class="line">    visit_function = visit_declaration</span>
<a id="line484"></a><span class="lineno">484</span>
<a id="line485"></a><span class="lineno">485</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DetailFormatter.html#visit_enum">visit_enum</a>(self, enum):</span>
<a id="line486"></a><span class="lineno">486</span>
<a id="line487"></a><span class="lineno">487</span><span class="line">        <span class="py-keyword">if</span> self.processor.hide_undocumented <span class="py-keyword">and</span> <span class="py-keyword">not</span> declaration.annotations.get(<span class="py-string">'doc'</span>):</span>
<a id="line488"></a><span class="lineno">488</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line489"></a><span class="lineno">489</span>
<a id="line490"></a><span class="lineno">490</span><span class="line">        self.start_element(<span class="py-string">'section'</span>, id=reference(enum.name))</span>
<a id="line491"></a><span class="lineno">491</span><span class="line">        self.write_element(<span class="py-string">'title'</span>, escape(enum.name[-1]))</span>
<a id="line492"></a><span class="lineno">492</span><span class="line">        indexterm = self.element(<span class="py-string">'primary'</span>, escape(enum.name[-1]))</span>
<a id="line493"></a><span class="lineno">493</span><span class="line">        <span class="py-keyword">if</span> self.secondary_index:</span>
<a id="line494"></a><span class="lineno">494</span><span class="line">            indexterm += self.element(<span class="py-string">'secondary'</span>, escape(str(enum.name)))</span>
<a id="line495"></a><span class="lineno">495</span><span class="line">        self.write_element(<span class="py-string">'indexterm'</span>, indexterm, type=<span class="py-string">'types'</span>)</span>
<a id="line496"></a><span class="lineno">496</span>
<a id="line497"></a><span class="lineno">497</span><span class="line">        language = enum.file.annotations[<span class="py-string">'language'</span>]</span>
<a id="line498"></a><span class="lineno">498</span><span class="line">        syntax = _detail_syntax[language](self.output)</span>
<a id="line499"></a><span class="lineno">499</span><span class="line">        enum.accept(syntax)</span>
<a id="line500"></a><span class="lineno">500</span><span class="line">        syntax.finish()</span>
<a id="line501"></a><span class="lineno">501</span><span class="line">        self.process_doc(enum)</span>
<a id="line502"></a><span class="lineno">502</span><span class="line">        self.end_element()</span>
<a id="line503"></a><span class="lineno">503</span>
<a id="line504"></a><span class="lineno">504</span>
<a id="line505"></a><span class="lineno">505</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DocCache.html">DocCache</a>:</span>
<a id="line506"></a><span class="lineno">506</span><span class="line">    <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line507"></a><span class="lineno">507</span>
<a id="line508"></a><span class="lineno">508</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DocCache.html#__init__">__init__</a>(self, processor, markup_formatters):</span>
<a id="line509"></a><span class="lineno">509</span>
<a id="line510"></a><span class="lineno">510</span><span class="line">        self._processor = processor</span>
<a id="line511"></a><span class="lineno">511</span><span class="line">        self._markup_formatters = markup_formatters</span>
<a id="line512"></a><span class="lineno">512</span><span class="line">        <span class="py-comment"># Make sure we have a default markup formatter.</span></span>
<a id="line513"></a><span class="lineno">513</span><span class="line">        <span class="py-keyword">if</span> <span class="py-string">''</span> <span class="py-keyword">not</span> <span class="py-keyword">in</span> self._markup_formatters:</span>
<a id="line514"></a><span class="lineno">514</span><span class="line">            self._markup_formatters[<span class="py-string">''</span>] = Markup.Formatter()</span>
<a id="line515"></a><span class="lineno">515</span><span class="line">        <span class="py-keyword">for</span> f <span class="py-keyword">in</span> self._markup_formatters.values():</span>
<a id="line516"></a><span class="lineno">516</span><span class="line">            f.init(self._processor)</span>
<a id="line517"></a><span class="lineno">517</span><span class="line">        self._doc_cache = {}</span>
<a id="line518"></a><span class="lineno">518</span>
<a id="line519"></a><span class="lineno">519</span>
<a id="line520"></a><span class="lineno">520</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DocCache.html#_process">_process</a>(self, decl):</span>
<a id="line521"></a><span class="lineno">521</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the documentation for the given declaration.&quot;&quot;&quot;</span></span>
<a id="line522"></a><span class="lineno">522</span>
<a id="line523"></a><span class="lineno">523</span><span class="line">        key = id(decl)</span>
<a id="line524"></a><span class="lineno">524</span><span class="line">        <span class="py-keyword">if</span> key <span class="py-keyword">not</span> <span class="py-keyword">in</span> self._doc_cache:</span>
<a id="line525"></a><span class="lineno">525</span><span class="line">            doc = decl.annotations.get(<span class="py-string">'doc'</span>)</span>
<a id="line526"></a><span class="lineno">526</span><span class="line">            <span class="py-keyword">if</span> doc:</span>
<a id="line527"></a><span class="lineno">527</span><span class="line">                formatter = self._markup_formatters.get(doc.markup,</span>
<a id="line528"></a><span class="lineno">528</span><span class="line">                                                        self._markup_formatters[<span class="py-string">''</span>])</span>
<a id="line529"></a><span class="lineno">529</span><span class="line">                doc = formatter.format(decl)</span>
<a id="line530"></a><span class="lineno">530</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line531"></a><span class="lineno">531</span><span class="line">                doc = Markup.Struct()</span>
<a id="line532"></a><span class="lineno">532</span><span class="line">            self._doc_cache[key] = doc</span>
<a id="line533"></a><span class="lineno">533</span><span class="line">            <span class="py-keyword">return</span> doc</span>
<a id="line534"></a><span class="lineno">534</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line535"></a><span class="lineno">535</span><span class="line">            <span class="py-keyword">return</span> self._doc_cache[key]</span>
<a id="line536"></a><span class="lineno">536</span>
<a id="line537"></a><span class="lineno">537</span>
<a id="line538"></a><span class="lineno">538</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DocCache.html#summary">summary</a>(self, decl):</span>
<a id="line539"></a><span class="lineno">539</span><span class="line">        <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line540"></a><span class="lineno">540</span>
<a id="line541"></a><span class="lineno">541</span><span class="line">        doc = self._process(decl)</span>
<a id="line542"></a><span class="lineno">542</span><span class="line">        <span class="py-keyword">return</span> doc.summary</span>
<a id="line543"></a><span class="lineno">543</span>
<a id="line544"></a><span class="lineno">544</span>
<a id="line545"></a><span class="lineno">545</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/DocCache.html#details">details</a>(self, decl):</span>
<a id="line546"></a><span class="lineno">546</span><span class="line">        <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line547"></a><span class="lineno">547</span>
<a id="line548"></a><span class="lineno">548</span><span class="line">        doc = self._process(decl)</span>
<a id="line549"></a><span class="lineno">549</span><span class="line">        <span class="py-keyword">return</span> doc.details</span>
<a id="line550"></a><span class="lineno">550</span>
<a id="line551"></a><span class="lineno">551</span>
<a id="line552"></a><span class="lineno">552</span>
<a id="line553"></a><span class="lineno">553</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/Formatter.html">Formatter</a>(Processor):</span>
<a id="line554"></a><span class="lineno">554</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Generate a DocBook reference.&quot;&quot;&quot;</span></span>
<a id="line555"></a><span class="lineno">555</span>
<a id="line556"></a><span class="lineno">556</span><span class="line">    markup_formatters = Parameter({<span class="py-string">'rst'</span>:RST(),</span>
<a id="line557"></a><span class="lineno">557</span><span class="line">                                   <span class="py-string">'reStructuredText'</span>:RST(),</span>
<a id="line558"></a><span class="lineno">558</span><span class="line">                                   <span class="py-string">'javadoc'</span>:Javadoc()},</span>
<a id="line559"></a><span class="lineno">559</span><span class="line">                                  <span class="py-string">'Markup-specific formatters.'</span>)</span>
<a id="line560"></a><span class="lineno">560</span><span class="line">    title = Parameter(None, <span class="py-string">'title to be used in top-level section'</span>)</span>
<a id="line561"></a><span class="lineno">561</span><span class="line">    nested_modules = Parameter(False, <span class="py-string">&quot;&quot;&quot;Map the module tree to a tree of docbook sections.&quot;&quot;&quot;</span>)</span>
<a id="line562"></a><span class="lineno">562</span><span class="line">    generate_summary = Parameter(False, <span class="py-string">'generate scope summaries'</span>)</span>
<a id="line563"></a><span class="lineno">563</span><span class="line">    hide_undocumented = Parameter(False, <span class="py-string">'hide declarations without a doc-string'</span>)</span>
<a id="line564"></a><span class="lineno">564</span><span class="line">    inline_inherited_members = Parameter(False, <span class="py-string">'show inherited members'</span>)</span>
<a id="line565"></a><span class="lineno">565</span><span class="line">    secondary_index_terms = Parameter(True, <span class="py-string">'add fully-qualified names to index'</span>)</span>
<a id="line566"></a><span class="lineno">566</span><span class="line">    with_inheritance_graphs = Parameter(True, <span class="py-string">'whether inheritance graphs should be generated'</span>)</span>
<a id="line567"></a><span class="lineno">567</span><span class="line">    graph_color = Parameter(<span class="py-string">'#ffcc99'</span>, <span class="py-string">'base color for inheritance graphs'</span>)</span>
<a id="line568"></a><span class="lineno">568</span>
<a id="line569"></a><span class="lineno">569</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/DocBook/Formatter.html#process">process</a>(self, ir, **kwds):</span>
<a id="line570"></a><span class="lineno">570</span>
<a id="line571"></a><span class="lineno">571</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line572"></a><span class="lineno">572</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.output: <span class="py-keyword">raise</span> MissingArgument(<span class="py-string">'output'</span>)</span>
<a id="line573"></a><span class="lineno">573</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line574"></a><span class="lineno">574</span>
<a id="line575"></a><span class="lineno">575</span><span class="line">        self.documentation = DocCache(self, self.markup_formatters)</span>
<a id="line576"></a><span class="lineno">576</span><span class="line">        self.toc = TOC(Linker())</span>
<a id="line577"></a><span class="lineno">577</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> self.ir.asg.declarations:</span>
<a id="line578"></a><span class="lineno">578</span><span class="line">            d.accept(self.toc)</span>
<a id="line579"></a><span class="lineno">579</span>
<a id="line580"></a><span class="lineno">580</span><span class="line">        output = open(self.output, <span class="py-string">'w'</span>)</span>
<a id="line581"></a><span class="lineno">581</span><span class="line">        output.write(<span class="py-string">'&lt;section&gt;\n'</span>)</span>
<a id="line582"></a><span class="lineno">582</span><span class="line">        <span class="py-keyword">if</span> self.title:</span>
<a id="line583"></a><span class="lineno">583</span><span class="line">            output.write(<span class="py-string">'&lt;title&gt;%s&lt;/title&gt;\n'</span>%self.title)</span>
<a id="line584"></a><span class="lineno">584</span><span class="line">        detail_formatter = DetailFormatter(self, output,</span>
<a id="line585"></a><span class="lineno">585</span><span class="line">                                           os.path.dirname(self.output),</span>
<a id="line586"></a><span class="lineno">586</span><span class="line">                                           self.nested_modules,</span>
<a id="line587"></a><span class="lineno">587</span><span class="line">                                           self.secondary_index_terms,</span>
<a id="line588"></a><span class="lineno">588</span><span class="line">                                           self.with_inheritance_graphs,</span>
<a id="line589"></a><span class="lineno">589</span><span class="line">                                           self.graph_color)</span>
<a id="line590"></a><span class="lineno">590</span>
<a id="line591"></a><span class="lineno">591</span><span class="line">        declarations = self.ir.asg.declarations</span>
<a id="line592"></a><span class="lineno">592</span>
<a id="line593"></a><span class="lineno">593</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.nested_modules:</span>
<a id="line594"></a><span class="lineno">594</span>
<a id="line595"></a><span class="lineno">595</span><span class="line">            modules = [d <span class="py-keyword">for</span> d <span class="py-keyword">in</span> declarations <span class="py-keyword">if</span> isinstance(d, ASG.Module)]</span>
<a id="line596"></a><span class="lineno">596</span><span class="line">            detail_formatter.generate_module_list(modules)</span>
<a id="line597"></a><span class="lineno">597</span>
<a id="line598"></a><span class="lineno">598</span><span class="line">            module_lister = ModuleLister()</span>
<a id="line599"></a><span class="lineno">599</span><span class="line">            <span class="py-keyword">for</span> d <span class="py-keyword">in</span> self.ir.asg.declarations:</span>
<a id="line600"></a><span class="lineno">600</span><span class="line">                d.accept(module_lister)</span>
<a id="line601"></a><span class="lineno">601</span><span class="line">            modules = module_lister.modules</span>
<a id="line602"></a><span class="lineno">602</span><span class="line">            modules.sort(cmp=<span class="py-keyword">lambda</span> a,b:cmp(a.name, b.name))</span>
<a id="line603"></a><span class="lineno">603</span><span class="line">            declarations = [d <span class="py-keyword">for</span> d <span class="py-keyword">in</span> self.ir.asg.declarations</span>
<a id="line604"></a><span class="lineno">604</span><span class="line">                            <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(d, ASG.Module)]</span>
<a id="line605"></a><span class="lineno">605</span><span class="line">            declarations.sort(cmp=<span class="py-keyword">lambda</span> a,b:cmp(a.name, b.name))</span>
<a id="line606"></a><span class="lineno">606</span><span class="line">            declarations = modules + declarations</span>
<a id="line607"></a><span class="lineno">607</span>
<a id="line608"></a><span class="lineno">608</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> declarations:</span>
<a id="line609"></a><span class="lineno">609</span><span class="line">            d.accept(detail_formatter)</span>
<a id="line610"></a><span class="lineno">610</span>
<a id="line611"></a><span class="lineno">611</span><span class="line">        output.write(<span class="py-string">'&lt;/section&gt;\n'</span>)</span>
<a id="line612"></a><span class="lineno">612</span><span class="line">        output.close()</span>
<a id="line613"></a><span class="lineno">613</span>
<a id="line614"></a><span class="lineno">614</span><span class="line">        <span class="py-keyword">return</span> self.ir</span>
<a id="line615"></a><span class="lineno">615</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:13 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
